﻿//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                      //
//  Lichtsignale                                                                        //
//  _________________________________                                                   //
//                                                                                      //
//  Copyright (c) 2019 Reimar Grasbon                                                   //
//                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                      //
//  This software is subjected to the FreeBSD License. Redistribution and use in source //
//  and binary forms, with or without modification, are permitted provided that the     //
//  following conditions are met:                                                       //
//                                                                                      //
//  1. Redistributions of source code must retain the above copyright notice, this list //
//     of conditions and the following disclaimer.                                      //
//                                                                                      //
//  2. Redistributions in binary form must reproduce the above copyright notice, this   //
//     list of conditions and the following disclaimer in the documentation and/or      //
//     other materials provided with the distribution.                                  //
//                                                                                      //
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY //
//  EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED           //
//  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  //
//  IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,    //
//  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT  //
//  NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR  //
//  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,   //
//  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)  //
//  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE          //
//  POSSIBILITY OF SUCH DAMAGE.                                                         //
//                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////

#pragma once

#include "TypeDefs.h"
#include "Board.h"

//////////////////////////////////////////////////////////////////////////////////////////
//  Typen  ///////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
typedef enum                           // Ereignis-Lichtsignale:
{   LIGHTEVENTSIGNAL_NONE       =  0,  // · Kein Signal
    LIGHTSIGNAL_BLINK_1X        =  1,  // · Blinkt einmal
    LIGHTSIGNAL_BLINK_2X        =  2,  // · Blinkt zweimal
    LIGHTSIGNAL_BLINK_3X        =  3,  // · Blinkt dreimal
    LIGHTSIGNAL_BLINK_6X        =  4,  // · Blinkt sechsmal
    LIGHTSIGNAL_FLASH_1X        =  5,  // · Blitzt einmal
	LIGHTSIGNAL_FLASH_2X        =  6,  // · Blitzt zweimal
    LIGHTSIGNAL_FLASH_3X        =  7,  // · Blitzt dreimal
    LIGHTSIGNAL_FLASH_6X        =  8,  // · Blitzt sechsmal
	LIGHTSIGNAL_FADE_IN         =  9,  // · Einblenden
	LIGHTSIGNAL_FADE_OUT        = 10,  // · Ausblenden
	LIGHTSIGNAL_FLICKER         = 11,  // · Flackern
    LIGHTEVENTSIGNAL_NUMBER     = 12
} LightEventSignal;

typedef enum                           // Zustands-Lichtsignale:
{   LIGHTSTATESIGNAL_OFF        = 0,   // · Aus
	LIGHTSTATESIGNAL_ON         = 1,   // · Ein
	LIGHTSTATESIGNAL_BLINK      = 2,   // · Blinkt
	LIGHTSTATESIGNAL_FLASH      = 3,   // · Blitzt
	LIGHTSTATESIGNAL_PULSE      = 4,   // · Pulsiert
	LIGHTSTATESIGNAL_HEARTBEAT  = 5,   // · Herzschlag	
	LIGHTSTATESIGNAL_NUMBER     = 6
} LightStateSignal;

//////////////////////////////////////////////////////////////////////////////////////////
//  Funktionen  //////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
void			  LIGHTSIGNAL_Play(LightEventSignal, UInt08);
void			  LIGHTSIGNAL_Start(LightStateSignal, UInt08);
LightStateSignal  LIGHTSIGNAL_Current(void);
UInt08            LIGHTSIGNAL_Brightness(void);
void			  LIGHTSIGNAL_Stop(void);

//////////////////////////////////////////////////////////////////////////////////////////
//  Prozessaufrufe  //////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
void			  LIGHTSIGNAL_Startup(void);
void			  LIGHTSIGNAL_Proceed(void);
void			  LIGHTSIGNAL_Shutdown(void);

//////////////////////////////////////////////////////////////////////////////////////////
