﻿//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                      //
//  Tonsignale                                                                          //
//  _________________________________                                                   //
//                                                                                      //
//  Copyright (c) 2017 Reimar Grasbon                                                   //
//                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                      //
//  This software is subjected to the FreeBSD License. Redistribution and use in source //
//  and binary forms, with or without modification, are permitted provided that the     //
//  following conditions are met:                                                       //
//                                                                                      //
//  1. Redistributions of source code must retain the above copyright notice, this list //
//     of conditions and the following disclaimer.                                      //
//                                                                                      //
//  2. Redistributions in binary form must reproduce the above copyright notice, this   //
//     list of conditions and the following disclaimer in the documentation and/or      //
//     other materials provided with the distribution.                                  //
//                                                                                      //
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY //
//  EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED           //
//  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  //
//  IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,    //
//  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT  //
//  NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR  //
//  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,   //
//  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)  //
//  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE          //
//  POSSIBILITY OF SUCH DAMAGE.                                                         //
//                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////

#pragma once

#include "TypeDefs.h"

//////////////////////////////////////////////////////////////////////////////////////////
//  Typen  ///////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
typedef enum							   // Ereignis-Tonsignale:
{   TONEEVENTSIGNAL_NONE           =  0,   // · Kein Signal
	TONEEVENTSIGNAL_LOW_HIGH       =  1,   // · Tief Hoch
	TONEEVENTSIGNAL_HIGH_LOW       =  2,   // · Hoch Tief
	TONEEVENTSIGNAL_LOW_MID_HIGH   =  3,   // · Tief Mitte Hoch
	TONEEVENTSIGNAL_HIGH_MID_LOW   =  4,   // · Hoch Mitte Tief	
	TONEEVENTSIGNAL_KEY_DOWN       =  5,   // · Taste gedrückt
	TONEEVENTSIGNAL_C6_TO_C8       =  6,   // · C6 zu C8
	TONEEVENTSIGNAL_DUO_RING       =  7,   // · Doppelton
	TONEEVENTSIGNAL_TRIPPEL_RING   =  8,   // · Trippelton
	TONEEVENTSIGNAL_TWEET          =  9,   // · Zwitscher
	TONEEVENTSIGNAL_SHORT_BEEP_C6  = 10,   // · Kurzer Piepton C7
	TONEEVENTSIGNAL_LONG_BEEP_C6   = 11,   // · Langer Piepton C7
	TONEEVENTSIGNAL_SHORT_BEEP_C8  = 12,   // · Kurzer Piepton C8
	TONEEVENTSIGNAL_LONG_BEEP_C8   = 13,   // · Langer Piepton C8
	TONEEVENTSIGNAL_SHORT_BEEP_C9  = 14,   // · Kurzer Piepton C9
	TONEEVENTSIGNAL_LONG_BEEP_C9   = 15,   // · Langer Piepton C9	
	TONEEVENTSIGNAL_NUMBER         = 16
} ToneEventSignal;

typedef enum							   // Zustands-Tonsignale:
{   TONESTATESIGNAL_OFF            =  0,   // · Aus
	TONESTATESIGNAL_TRICKLE        =  1,   // · Tropfen
	TONESTATESIGNAL_TICKING        =  2,   // · Ticken
	TONESTATESIGNAL_DUO_TONE_TICKS =  3,   // · Martinticks
	TONESTATESIGNAL_SHORT_BEEPS_D7 =  4,   // · Kurzer Piepton D7
	TONESTATESIGNAL_LONG_BEEPS_D7  =  5,   // · Langer Piepton D7
	TONESTATESIGNAL_NUMBER         =  6
} ToneStateSignal;

//////////////////////////////////////////////////////////////////////////////////////////
//  Funktionen  //////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
void            TONESIGNAL_Play(ToneEventSignal);
void            TONESIGNAL_Start(ToneStateSignal);
ToneStateSignal TONESIGNAL_Current(void);
void            TONESIGNAL_Stop(void);

//////////////////////////////////////////////////////////////////////////////////////////
//  Prozessaufrufe  //////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
void            TONESIGNAL_Startup(void);
void            TONESIGNAL_Proceed(void);
void            TONESIGNAL_Shutdown(void);

//////////////////////////////////////////////////////////////////////////////////////////

